<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Canvas Custom Phone Case</title>
</head>
<body>

<input type="file" id="formFile" accept="image/*">
<canvas id="canvas" style="border:1px solid #000;"></canvas>

<script>
    document.addEventListener('DOMContentLoaded', function() {
        let isDragging = false;
        let canvas = document.getElementById('canvas');
        let ctx = canvas.getContext('2d');
        let caseImage = new Image();
        let backgroundImage = new Image();
        let offset = { x: 0, y: 0 };
        let startX, startY;
        caseImage.onload = function() {
            canvas.width = caseImage.width;
            canvas.height = caseImage.height;
            ctx.drawImage(caseImage, 0, 0, caseImage.width, caseImage.height);
        };
        caseImage.src = 'iphone-11-pruhledne-2.png';

        function handleMouseDown(event) {
            let mouseX = event.clientX - canvas.offsetLeft;
            let mouseY = event.clientY - canvas.offsetTop;

            if (
                mouseX >= offset.x &&
                mouseX <= offset.x + backgroundImage.width &&
                mouseY >= offset.y &&
                mouseY <= offset.y + backgroundImage.height
            ) {
                isDragging = true;
                startX = mouseX - offset.x;
                startY = mouseY - offset.y;
            }
        }

        function handleMouseMove(event) {
            if (isDragging) {
                let mouseX = event.clientX - canvas.offsetLeft;
                let mouseY = event.clientY - canvas.offsetTop;

                offset.x = mouseX - startX;
                offset.y = mouseY - startY;

                let scale = Math.min(canvas.width / backgroundImage.width, canvas.height / backgroundImage.height);

                ctx.clearRect(0, 0, canvas.width, canvas.height);
                ctx.drawImage(caseImage, 0, 0);
                ctx.globalCompositeOperation = 'destination-over';
                ctx.drawImage(backgroundImage, offset.x, offset.y, backgroundImage.width * scale, backgroundImage.height * scale);
            }
        }

        function handleMouseUp() {
            isDragging = false;
        }

        canvas.addEventListener('mousedown', handleMouseDown);
        canvas.addEventListener('mouseup', handleMouseUp);
        canvas.addEventListener('mousemove', handleMouseMove);

        document.getElementById('formFile').addEventListener('change', function() {
            let file = this.files[0];
            if (file) {
                let reader = new FileReader();
                reader.onload = function(e) {
                    backgroundImage.onload = function() {
                        ctx.globalCompositeOperation = 'destination-over';
                        let scale = Math.min(canvas.width / backgroundImage.width, canvas.height / backgroundImage.height);
                        let x = (canvas.width / 2) - (backgroundImage.width / 2) * scale;
                        let y = (canvas.height / 2) - (backgroundImage.height / 2) * scale;
                        ctx.drawImage(backgroundImage, x, y, backgroundImage.width * scale, backgroundImage.height * scale);                    };
                    backgroundImage.src = e.target.result;
                };
                reader.readAsDataURL(file);
            }
        }, false);
    });
</script>

</body>
</html>
